package compilo;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

import org.antlr.codegen.CodeGenerator;
import org.antlr.runtime.ANTLRInputStream;
import org.antlr.runtime.CommonTokenStream;
import org.antlr.runtime.RecognitionException;
import org.antlr.runtime.tree.CommonTree;

public class Main {
	public static void main(String[] args) {
        ANTLRInputStream input;

		try {
			input = new ANTLRInputStream(new FileInputStream(new File("src/in.txt")));
			ExprLexer lexer = new ExprLexer(input);
	        ExprParser parser = new ExprParser(new CommonTokenStream(lexer));
	        CommonTree tree = (CommonTree) parser.prog().getTree();

	        ExprSemGen esg = new ExprSemGen(true);
	        esg.complete(tree);
	        esg.printOut("src/out.c");
	        
	        /*
	         * Calling gcc
	         */
	        String cmd = "gcc -Wall -o src/tst src/out.c";
	        Runtime sys = Runtime.getRuntime();
	        Process p = sys.exec(cmd);
	        /*
	         * end call
	         */

		} catch (IOException e) {
			e.printStackTrace();
		} catch (RecognitionException e) {
			e.printStackTrace();
		} catch (SemException e) {
			e.printError();
		}
	}
}