package compilo;
import org.antlr.runtime.tree.Tree;

public class SemException extends Exception {
	private Tree ast;

	public SemException(String message) {
		super(message);
	}
	
	public SemException(String message, Tree ast) {
		super(message);
		this.ast = ast;
	}
	
	public void printError() {
		if(ast != null)
			System.err.print("Line " + ast.getLine() + " : ");
			System.err.print("[" + printTree(ast) + "] ");
		
		System.err.println(getMessage());
	}

	private String printTree(Tree t) {
		String print = "";
		
		if(t != null) {
			print = t + " ";
			
			for(int i = 0; i < t.getChildCount(); i++)
				print += printTree(t.getChild(i));
		}
		return print;
	}
	
	public boolean hasAST() {
		return ast != null;
	}
}
